function EWmonController(lang) {

	//back button management init
	this.last_view = new Array();
	this.domainDataViews = new Array();

	this.current_view = "ewmon_layout_login";

	this.currentUsername = "";
	this.currentPassword = "";
	this.currentDomain = "";

	this.deviceWidth = document.body.offsetWidth;
	this.deviceHeight = document.body.offsetHeight;

	this.ewmon_view
	this.startWithLanguage(lang, this);

	this.currentType = "";
	this.currentSubType = "";
	this.currentKeys = new Array();

}

EWmonController.prototype.updateDeviceSize = function() {
	this.deviceWidth = document.body.offsetWidth;
	this.deviceHeight = document.body.offsetHeight;
}

EWmonController.prototype.startWithLanguage = function(lang, controller) {
	dhx.ajax().get(LANG_FILE_PATH + lang, "", function(text) {
		DATA_LANG = dhx.DataDriver.json.toObject(text);
		ewmon_view = new EWmonView();
		dhx.ui(ewmon_view.getRoot());
		ewmon_view.initEventHandler(controller);
		dhx.extend($$('ewmon_app'), dhx.ui.overlay);
	});
}

EWmonController.prototype.switchView = function(next) {
	this.last_view.push(this.current_view);
	this.current_view = next;
	$$(this.current_view).show();
}

EWmonController.prototype.lastView = function() {
	this.current_view = this.last_view.pop();
	$$(this.current_view).show();
}

EWmonController.prototype.resetCurrentData = function() {
		ewmon_controller.currentKeys = new Array();
		ewmon_controller.currentType = "";
		ewmon_controller.currentSubType = "";
		ewmon_controller.currentDomain = "";
}

EWmonController.prototype.validateUserPass = function(username, password) {
	if($$('ewmon_form_login').validate() == false) {
			dhx.notice(DATA_LANG.fieldErrors);
	} else{
	
		var username=$$('ewmon_text_login_username').getValue();
		var password=$$('ewmon_text_login_password').getValue();
		var address = REST_getDomains + "username/" + username + "/password/" + password + "/";
		address = "examples/domains_" + username + "_" + password + ".xml";
		//alert(address);
		$$('ewmon_app').showOverlay();
	
		dhx.ajax().get(address, "", {
			error : function(text, xml, XmlHttpRequest) {
				dhx.notice(DATA_LANG.loginError);
				$$('ewmon_app').hideOverlay();
			},
			success : function(text, xml) {
				var xml = dhx.DataDriver.xml.toObject(text, xml);
	
				//alert(text);
	
				$$('ewmon_list_main_domain').parse(xml, "xml");
				ewmon_controller.currentUsername = username;
				ewmon_controller.currentPassword = password;
				ewmon_controller.domainDataViews = new Array();
				buildErrorsGrid();
				ewmon_controller.switchView('ewmon_layout_main');
				$$('ewmon_app').hideOverlay();
	
			}
		});
	}
}

EWmonController.prototype.validateStatisticsForm = function() {
		var startInt=0;
		var endInt=0;
		var initD=$$('ewmon_datepicker_main_oks_from').data.text;
		var endD=$$('ewmon_datepicker_main_oks_to').data.text;
		var group=$$('ewmon_richselect_main_oks_group').data.value;
		var source=$$('ewmon_richselect_main_oks_interlocutorsSource').data.value;
		var destination=$$('ewmon_richselect_main_oks_interlocutorsDestination').data.value;
		if (initD!=null && endD!=null){
			var startInt=parseInt(initD.substring(6, 10)+initD.substring(3, 5)+initD.substring(0, 2));
			var endInt=parseInt(endD.substring(6, 10)+endD.substring(3, 5)+endD.substring(0, 2));
		}
		//validation
		
		if($$('ewmon_panel_form_main_oks').validate() == false){
			dhx.notice(DATA_LANG.fieldErrors);
		}
		if(initD==null || endD==null || startInt>endInt){
			dhx.notice(DATA_LANG.errorInDate);
		}
		if(!($$('ewmon_panel_form_main_oks').validate() == false || initD==null || endD==null || startInt>endInt)) {
				buildChartFromData(initD,endD , $$('ewmon_richselect_main_oks_msgtype').getValue(),group, source, destination);
		}
		
}

EWmonController.prototype.showDocumentOnScreen = function(id) {
	
	var keys = new Array();
	var formatType= "TXT"
	for(var i = 0; i < ewmon_controller.currentKeys.length; i++) {
		var item = $$('ewmon_grid_domain').item(id);
		keys.push(item[ewmon_controller.currentKeys[i]]);
		if (item["interfaz"]!=null)
			formatType=item["interfaz"].substring(0,3);
		else if (item["docinterfaz"]!=null)
			formatType=item["docinterfaz"].substring(0,3);
	};

	var address = "";
	var addressPDF = "";
	var addresses = new Array();
	switch(parseInt(ewmon_controller.currentType)) {
		case 0:
			switch(parseInt(ewmon_controller.currentSubType)) {
				case 0:
					address = REST_getEdiDocument + "username/" + ewmon_controller.currentUsername + "/password/" + ewmon_controller.currentPassword + "/domain/" + ewmon_controller.currentDomain + "/idDocument/" + keys[0] + "/";
					addressPDF = REST_getEdiDocumentList + "username/" + ewmon_controller.currentUsername + "/password/" + ewmon_controller.currentPassword + "/domain/" + ewmon_controller.currentDomain + "/idDocument/" + keys[0] + "/";
					addresses.push({id : 1,name : DATA_LANG.listPDF   ,url : addressPDF ,showType : "childbrowser",format : formatType,});
					addresses.push({id : 2,name : DATA_LANG.listSourceCode ,url : address    ,showType : "popup"       ,format : formatType,});
					
					break;
			}
			break;
		case 1:
			switch(parseInt(ewmon_controller.currentSubType)) {
				case 0:
					address = REST_getEbiDocument + "username/" + ewmon_controller.currentUsername + "/password/" + ewmon_controller.currentPassword + "/domain/" + ewmon_controller.currentDomain + "/idDocument/" + keys[0] + "/";
					addresses.push({id : 1,	name : DATA_LANG.listSourceCode ,url : address,showType : "popup",format : formatType});
					break;
			}
			break;
	}

	if(addresses.length > 1) {
		showDocumentElections(addresses);

	} else if(addresses.length == 1) {
		showDocument(addresses[0].addess, addresses[0].showType);
	}
}

EWmonController.prototype.getInterfaces = function(domain) {
	
	$$('ewmon_richselect_main_oks_msgtype_list').clearAll();
	
	$$('ewmon_richselect_main_oks_msgtype').setValue("");
	

	var address = REST_getDomainInterfaces + "username/" + ewmon_controller.currentUsername + "/password/" + ewmon_controller.currentPassword + "/domain/" + ewmon_controller.currentDomain + "/";
	address = "examples/interfaces_" + ewmon_controller.currentUsername + "_" + ewmon_controller.currentPassword + "_" + domain + ".xml"

	var result = dhx.ajax().post(address, "", {
		error : function(text, xml, XmlHttpRequest) {
			dhx.notice(DATA_LANG.retrivingDataError);
		},
		success : function(text, xml) {
			var driver = dhx.DataDriver.xml;
			var xml = driver.toObject(text, xml);

			var jsonObj = new Array();
			//build ogject {id:"x", value:"y"}

			for(var i = 0; i < xml.childNodes[0].childNodes.length; i++) {
				if(xml.childNodes[0].childNodes[i] instanceof Element && xml.childNodes[0].childNodes[i].tagName == "interface") {
					//we are in <interface>
					for(var k = 0; k < xml.childNodes[0].childNodes[i].childNodes.length; k++) {
						if(xml.childNodes[0].childNodes[i].childNodes[k] instanceof Element && xml.childNodes[0].childNodes[i].childNodes[k].tagName == "name") {
							//we are in <name>
							var dataName = xml.childNodes[0].childNodes[i].childNodes[k].textContent;
							jsonObj.push({
								id : dataName,
								value : dataName
							});
						}
					}

				}
			}

			$$('ewmon_richselect_main_oks_msgtype_list').parse(jsonObj, "json");
		}
	});
}


EWmonController.prototype.getInterlocutors = function() {

	$$('ewmon_popup_main_interlocutors_list').clearAll();
	
	$$('ewmon_richselect_main_oks_interlocutorsSource').setValue("");
	$$('ewmon_richselect_main_oks_interlocutorsDestination').setValue("");
	
	//building parameters
	var parameters={};
	parameters["username"]=ewmon_controller.currentUsername;
	parameters["password"]=ewmon_controller.currentPassword;
	parameters["domain"]=ewmon_controller.currentDomain;
	parameters["includeLogics"]="false";

	var address = REST_getDomainInterlocutors;
	address = "examples/interlocutorslist.xml"
	
	

	var result = dhx.ajax().post(address, parameters, {
		error : function(text, xml, XmlHttpRequest) {
			dhx.notice(DATA_LANG.retrivingDataError);
		},
		success : function(text, xml) {
			$$('ewmon_popup_main_interlocutors_list').parse(text, "xml");
		}
	});
}

EWmonController.prototype.runFirstStatistic = function() {
	var currentDate = new Date();
	var day="0"+currentDate.getDate();
	var month="0"+(currentDate.getMonth()+1);
	var year=currentDate.getFullYear();
	var endD= day.substring(day.length-2,day.length) +"/"+ month.substring(month.length-2,month.length) +"/"+ year;
    
	var currentYear=currentDate.getFullYear();
    
	var lastYear=currentDate;
	lastYear.setFullYear(currentYear-1);
	
	day="0"+lastYear.getDate();
	month="0"+(lastYear.getMonth()+1);
	year=lastYear.getFullYear();
	var initD=day.substring(day.length-2,day.length) +"/"+ month.substring(month.length-2,month.length) +"/"+ year;
	
	//lastyear statistics grouped per day
	buildChartFromData(initD, endD, "", "1", "", "");
}
